<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Teknisa\CRM\Factory\GerParcnegocioInfoFactory;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class GerParcnegocioInfoController extends TeknisaCrud {
    protected $dataSourceName = 'ger_parcnegocioinfo';
    protected $parameterBagColumns;
    protected $infoFactory;
    
    public function __construct($crudService, $parameterBagColumns, $factory) {
        parent::__construct($crudService, $parameterBagColumns);
        $this->infoFactory = $factory;
    }
    
    public function saveInfo(DTO\Request\DataSet $request, DTO\Response $response) {
        $row = $request->getDataSet()->getRows()[0];
        
        try {
            if($row["__is_new"]) {
                parent::save($request, $response);
            } else {
                $this->infoFactory->update($row);
            }
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
        
    }
}