<?php
namespace Teknisa\CRM\Service;

use Doctrine\ORM\EntityManager;
use Teknisa\CRM\Factory\InterlocutoresPendentesFactory;

class InterlocutoresPendentesService {
    
    protected $interlocFactory;
    protected $entityManager;
    
    public function __construct($entityManager, InterlocutoresPendentesFactory $interlocFactory) {
        $this->interlocFactory = $interlocFactory;
        $this->entityManager = $entityManager;
    }

    public function setClientInPendInt($row){

        $connection = $this->entityManager->getConnection();

        try{
            
            $connection->beginTransaction();            
            
            //Seta o parceiro do cliente no interlocutor
            $interloc = $this->interlocFactory->setParcOnInterloc($row);
            //Seta o cdcliente no operador do interlocutor
            $oper     = $this->interlocFactory->setClientOnOper($row);
            //Seta o nrparcnegocio do cliente nos tickets do interlocutor
            $tickets  = $this->interlocFactory->setClientOnTickets($row);
            
            $connection->commit();
            return array(
                'NRSEQINTERLOCUTOR'=> $interloc,
                'CDOPERADOR'       => $oper,
                'NRSEQCONTATO'     => $tickets
            );
            
        }catch(\Exception $e){
            
            $connection->rollBack();
            return $e->getMessage();
        }
    }
    
    public function setDtultatuInterloc($nrseqinterlocutor){
        $connection = $this->entityManager->getConnection();

        try{
            
            $connection->beginTransaction();
            $return = $this->interlocFactory->setDtultatuInterloc($nrseqinterlocutor);
            $connection->commit();
            return $return;
            
        }catch(\Exception $e){
            
            $connection->rollBack();
            return $e->getMessage();
        }
        
    }
    
    public function cancelInterloc($row){

        $connection = $this->entityManager->getConnection();

        try{
            
            $connection->beginTransaction();            
            
            $this->interlocFactory->cancelTickets($row);
           /* //Exclui o parceiro do interlocutor
            $this->interlocFactory->deleteParcnegocio($row);
            //Exclui o operador (se houver)
            if($row['ATIVO'] === 'S'){
                $this->interlocFactory->deleteOper($row);
            }
            //Cancela os tickets do interlocutor
            */
            $connection->commit();
            return true;
            
        }catch(\Exception $e){
            
            $connection->rollBack();
            return $e->getMessage();
        }
    }
}