<?php
namespace Teknisa\CRM\Service;

use Doctrine\ORM\EntityManager;
use Teknisa\CRM\Factory\crm00002006FilaContatoFactory;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;

class crm00002006FilaContatoService {
    protected $filaContatoFactory;
    protected $newCode;
    protected $environment;
    
    public function __construct(crm00002006FilaContatoFactory $filaContatoFactory, NewCode $newCode, Environment $environment) {
        
        $this->filaContatoFactory = $filaContatoFactory;
        $this->newCode = $newCode;
        $this->environment = $environment;
        
    }
    
    public function inserirTarefa($params, $entityManager = null) {
        $nrorg = is_null($this->environment->getNrOrg()) ? $params['NRORG'] : $this->environment->getNrOrg();
        $nrseqfilaconta = $this->newCode->getCodeByTableName("FILACONTATO", $nrorg, 1, 10, true);
        $params["NRSEQFILACONTA"] = $nrseqfilaconta;
        $this->filaContatoFactory->inserirTarefa($params, $entityManager);
        return $nrseqfilaconta;
    }
    
    public function callForSetTaskEndDate($row){
        
        $paramsSetTaskEndDate = array(
            
            "NRSEQFILACONTA"        => $row["NRSEQFILACONTA"],
            "NRORG"                 => $row["NRORG"]
            
        );
        
        $this->filaContatoFactory->requestForSetTaskEndDate($paramsSetTaskEndDate);
        
    }
    
    public function updateEvol($row, $nrseqfilaconta){
        
        $paramsSetTaskEndDate = array(
            
            "NRSEQFILACONTA"        => $nrseqfilaconta,
            "NRSEQEVOLCONT"         => $row["NRSEQEVOLCONT"],
            "NRORG"                 => $row["NRORG"]
            
        );
        
        $this->filaContatoFactory->updateEvol($paramsSetTaskEndDate);
        
    }
    
    public function callForDeactivateOpportunityTask($row){
        
        $paramsDeactivateTask = array(
            
            "NRSEQFILACONTA"        => $row["NRSEQFILACONTA"]
            
        );
        
        $this->filaContatoFactory->requestForDeactivateOpportunityTask($paramsDeactivateTask);
        
    }
}